#include <zthread/Barrier.h>
#include <zthread/Condition.h>
#include <zthread/Guard.h>
#include <zthread/Mutex.h>
#include <zthread/Thread.h>

#include <iostream>

using namespace ZThread;
using namespace std;

Barrier<> ready(4), restart(4);

class RED : public Runnable {
public:

  virtual ~RED() {}

  virtual void run() throw() {

    try {

      cout << "RED is waiting..." << endl;
      Thread::sleep(2000);
      cout << "RED is awake..." << endl;

      ready.acquire(); // critical point
      restart.acquire(); 
 
    } catch(...) {
      cerr << "RED Unexcpected Exception!" << endl;
    }

  }

  
};

class BLUE : public Runnable {
public:

  virtual ~BLUE() {}
  virtual void run() throw() {

    try {

      cout << "BLUE is waiting..." << endl;
      Thread::sleep(2000);
      cout << "BLUE is awake..." << endl;

      ready.acquire(); // critical point
      restart.acquire(); 
 
    } catch(...) {
      cerr << "BLUE Unexcpected Exception!" << endl;
    }

  }
  
};

class GREEN : public Runnable {
public:

  virtual ~GREEN() {}

  virtual void run() throw() {

    try {

      cout << "GREEN is waiting..." << endl;
      Thread::sleep(2000);
      cout << "GREEN is awake..." << endl;

      ready.acquire(); // critical point
      restart.acquire(); 
 
    } catch(...) {
      cerr << "GREEN Unexcpected Exception!" << endl;
    }

  }
  
};



int main() {

  try {

    Thread th[3];

    RED r;
    BLUE b;
    GREEN g;

    th[0].run(&r);
    th[1].run(&b);
    th[2].run(&g);


    cout << "Main is waiting..." << endl;
    ready.acquire(); 
    
    // After all the workers reach the barrier execution
    // will continue

    Thread::yield();
    cout << "Main is waiting... (again)" << endl;    

    // switch the data set or someother operation you need to be 
    // sure the working threads will not interrupt
    
    restart.acquire(); // Unblock the threads waiting on this barrier
    
    th[0].join();
    th[1].join();
    th[2].join();

  } catch(...) {
    cerr << "Main Unexpected Exception!" << endl;
  }

  return 0;

}





















