#include "ExternalExecutor.h"

#include <zthread/AsyncExecutor.h>
#include <zthread/SyncExecutor.h>
#include <zthread/PoolExecutor.h>
#include <zthread/Thread.h>

#include <iostream>

#define TASKS 25
#define POOL_SIZE 4
#define CANCEL_POINT 20

using namespace std;
using namespace ZThread;

class Task : public Runnable {

  int n;

public:
  
  Task(int id) : n(id) {
  }

  virtual ~Task() {
  }

  virtual void run() throw() {

    Thread::sleep(1000);
    cerr << "Task " << n << endl;

  }

};

//static AsyncExecutor<true> executor;
static PoolExecutor<true> executor(POOL_SIZE);

int main(int argc, char* argv[]) {

  try {

    //PoolExecutor executor(POOL_SIZE);

    try {

      for(int n = 0; n < TASKS; n++) {
        executor.execute( new Task(n) );
        cerr << "Add task" << endl;
        
        if(n == CANCEL_POINT)
          executor.cancel(); // accept no more tasks
      }
      

    } catch(Cancelation_Exception&) {
      cerr << "Cancelation" << endl;
    }

    cerr << "Waiting for tasks to complete" << endl;

    executor.cancel(); // accept no more tasks
    Thread::sleep(2000);
    //    executor.join();

  } catch(Synchronization_Exception& e) { 
    cerr << e.what() << endl; 
  } catch(...) {
    cerr << "Unexpected error" << endl;
  }

#ifdef WIN32
  cerr << "Press a key" << endl;
  getchar(); // Otherwise the console window will close to quickly
#endif
  return 0;

}
