#include <iostream>

#include <zthread/Condition.h>
#include <zthread/Guard.h>
#include <zthread/Mutex.h>
#include <zthread/Thread.h>

using namespace ZThread;
using namespace std;

Condition sleeper;

class TimeoutThread : public Thread {

  Mutex lock;

public:

  virtual ~TimeoutThread() throw()  {}

  virtual void run() throw()  {
    
    Guard<Mutex> g(lock);

    cout << "Go to sleep" << endl;

    try {

      sleeper.wait(lock, 30*1000);

    } catch(Synchronization_Exception &e) {
      cout << "Error: " << e.what() << endl;
    }

    cout << "Woke up" << endl;

  }

};

int main(int argc, char **argv) {
  
  TimeoutThread t; 
  t.start();

  Thread::sleep(2000);

  sleeper.signal();

  Thread::sleep(2000);

  t.join();
  return 0;

}

