#include <iostream>
using namespace std;

#include <zthread/TimerThread.h>
using namespace ZThread;

class Logger : public TimerListener {
public:

  virtual void notify(const Timer* t, const TimerEvent&) {
    cerr << "Got a timer event from " << (void*)t << endl;
  }

};

static TimerThread<true> timer;    

int main() {

  try {

    Logger l;

    timer.subscribe(&l);
    timer.addEvent(500);

    timer.start();

    Thread::sleep(10000);

    timer.cancel();

  } catch(...) {
    cerr << "Unhandled exception" << endl;
  }

#ifdef _WIN32
  getchar();
#endif

  return 0;

}
